
#include "User Interface.h"
#include "lcd4bit.h"
#include "keypad.h"

unsigned char CurChar = '0', PrevChar;

void ShowError()
{
	gotoxy_lcd(1, 1);
	print_lcd("                \0");
	gotoxy_lcd(1, 2);
	print_lcd("           Error\0");
}

void ShowValue(unsigned long Value)
{
	unsigned char ch, Ctr = 0;
	do
	{
		ch = Value % 10;
		gotoxy_lcd(16 - Ctr ++, 2);
		putc_lcd(ch + '0');
		Value /= 10;
	}
	while(Value > 0 && Ctr < MAX_OUT_CHARS);
	while(Ctr < MAX_OUT_CHARS)
	{
		gotoxy_lcd(16 - Ctr ++, 2);
		putc_lcd(' ');
	}
}

long GetValue(unsigned char nVal)
{
	unsigned char Ctr = 0;
	long Value = 0;
	if(nVal >= '0' && nVal <= '9')
	{
		Value = nVal - '0';
		ShowValue(Value);
		if(nVal != '0')
			Ctr = 1;
	}
	do
	{
		CurChar = kgetch();
		if(CurChar != '*' && CurChar != '#')
		{
			Value *= 10;
			Value += CurChar - '0';
			ShowValue(Value);
			Ctr ++;
		}
	}
	while(CurChar != '*' && CurChar != '#' && Ctr < MAX_IN_CHARS);
	if(Ctr >= MAX_IN_CHARS)
	{
		do
		{
			CurChar = kgetch();
		}
		while(CurChar != '*' && CurChar != '#');
	}
	return Value;
}

void ShowCmd(unsigned char Cmd)
{
	gotoxy_lcd(1, 1);
	if(Cmd == '#')
		Cmd = '=';
	switch(Cmd)
	{
	case 's':
		print_lcd("Sin\0");
		break;
	case 'c':
		print_lcd("Cos\0");
		break;
	case 't':
		print_lcd("Tan\0");
		break;
	case ' ':
		print_lcd("   \0");
		break;
	default:
		putc_lcd(Cmd);
		print_lcd("  \0");
		break;
	}
}

unsigned char GetOperator()
{
	unsigned char Cmd = CurChar;
	ShowCmd(CurChar);
	do
	{
		CurChar = kgetch();
		if(CurChar == '*')
		{
			switch(Cmd)
			{
			default:	Cmd = '*';	break;
			case '*':	Cmd = '/';	break;
			case '/':	Cmd = '+';	break;
			case '+':	Cmd = '-';	break;
			case '-':	Cmd = '*';	break;
			}
			ShowCmd(Cmd);
		}
	}
	while(CurChar == '*');
	if(CurChar == '#')
		ShowCmd('=');
	return Cmd;
}

