///////////////////////////////////////////////////////////
// Company         : Micro Digital                       //
// Address         : Office # C7 Raza Plaza              //
//                   DAV College Road                    //
//                   Rawalpindi,                         //
//                   Pakistan.                           //
// Programmed By   : Rashid Mehmood                      //
// Project Name    : 8051 Calculator with 16x2 LCD       //
//                   and Telephone Keypad                //
// Crystal         : 24.000000 MHz                       //
// Microcontroller : AT89C51-C52-C55-S51-S52             //
///////////////////////////////////////////////////////////

#include <AT89x51.h>
#include "User Interface.h"
#include "lcd4bit.h"
#include "keypad.h"

extern unsigned char CurChar;

// Main entry 
// point.
void main()
{
	unsigned char i = 0;
	long Ans, Cmd = ' ';
	unsigned char ValCount = 0;
	long Cur = 0, Prev = 0;

	init_lcd();
	Reset();
	while(1)
	{
Start:
		Reset();
		Prev = GetValue(CurChar);
		if(CurChar == '#')
		{
			CurChar = '0';
			goto Start;
		}
Step2:
		Cmd = GetOperator();
		if(CurChar == '#')
		{
			if(Cmd == '+' || Cmd == '-')
				Cur = 0;
			else
				Cur = Prev;
		}
		else
			Cur = GetValue(CurChar);
		Ans = 0;
		switch(Cmd)
		{
		case '/':
			if(Cur != 0)
				Ans = Prev / Cur;
			else
			{
				ShowError();
				while(kgetch() != '#');
				goto Start;
			}
			break;
		case '*':
			Ans = Prev * Cur;
			break;
		case '+':
			Ans = Prev + Cur;
			break;
		case '-':
			Ans = Prev - Cur;
			break;
		}
		ShowCmd('=');
		ShowValue(Ans);
		
		CurChar = kgetch();
		
		switch(CurChar)
		{
		case '*':
			Prev = Ans;
			goto Step2;
		case '#':
			CurChar = '0';
		default:
			goto Start;
			break;
		}
	}
}

